# DBaaS Management


<style>
  span[class^="pill-"] {
    color: white;
    padding: 2px 12px;
    border-radius: 12px;
    font-size: 0.6em;
    vertical-align: middle;
    margin-right: 12px;
    font-family: sans-serif;
    font-weight: bold;
    display: inline-block;
    line-height: 1;
  }
  span.pill-GET { background-color: #61affe; }
  span.pill-POST { background-color: #49cc90; }
  span.pill-PUT { background-color: #fca130; }
  span.pill-DELETE { background-color: #f93e3e; }
  span.pill-PATCH { background-color: #50e3c2; }
  span[class^="pill-"]:after {
    content: attr(data-label);
    font-size: 0.9rem;
  }
</style>

Operational management for DBaaS services: logs, metrics, service types and lifecycle.

[Read more](https://community.exoscale.com/product/dbaas/)

## <span data-label="POST" class="pill-POST"></span>create-dbaas-clickhouse-user

[BETA] Create a DBaaS ClickHouse user

```
POST /dbaas-clickhouse/{service-name}/user
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `username` | string | **yes** | Username<br/><br/>Min length: `1`. Max length: `64`. |
| `password` | string | no | Password<br/><br/>Min length: `8`. Max length: `256`. |
| `roles` | array of [DBaaS Clickhouse User Role Input](/reference/api/_schemas/dbaas-clickhouse-user-role-input/) | no | ClickHouse roles to grant to the user |

<details>
<summary>Example</summary>

```json
{
  "password": "string",
  "roles": [
    {
      "uuid": "string"
    }
  ],
  "username": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `password` | string | ClickHouse password |
| `username` | string | ClickHouse username |

<details>
<summary>Example output</summary>

```json
{
  "password": "string",
  "username": "string"
}
```
</details>


SDK reference for `create-dbaas-clickhouse-user`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateDBAASClickhouseUser) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_dbaas_clickhouse_user) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createDbaasClickhouseUser(java.lang.String,com.exoscale.sdk.model.CreateDbaasClickhouseUserRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api create-dbaas-clickhouse-user`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-dbaas-clickhouse-user

[BETA] Delete a DBaaS ClickHouse user

```
DELETE /dbaas-clickhouse/{service-name}/user/{username}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |
| `username` | `path` | Min length: `1`. Max length: `64`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-dbaas-clickhouse-user`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteDBAASClickhouseUser) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_dbaas_clickhouse_user) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteDbaasClickhouseUser(java.lang.String,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api delete-dbaas-clickhouse-user`

## <span data-label="GET" class="pill-GET"></span>reveal-dbaas-clickhouse-user-password

[BETA] Reveal the secrets of a DBaaS ClickHouse user

```
GET /dbaas-clickhouse/{service-name}/user/{username}/password/reveal
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |
| `username` | `path` | Min length: `1`. Max length: `64`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `password` | string | ClickHouse password |
| `username` | string | ClickHouse username |

<details>
<summary>Example output</summary>

```json
{
  "password": "string",
  "username": "string"
}
```
</details>


SDK reference for `reveal-dbaas-clickhouse-user-password`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.RevealDBAASClickhouseUserPassword) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reveal_dbaas_clickhouse_user_password) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#revealDbaasClickhouseUserPassword(java.lang.String,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api reveal-dbaas-clickhouse-user-password`

## <span data-label="PUT" class="pill-PUT"></span>reset-dbaas-clickhouse-user-password

[BETA] Reset the credentials of a DBaaS ClickHouse user

```
PUT /dbaas-clickhouse/{service-name}/user/{username}/password/reset
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |
| `username` | `path` | Min length: `1`. Max length: `64`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `password` | string | no | New password<br/><br/>Min length: `8`. Max length: `256`. |

<details>
<summary>Example</summary>

```json
{
  "password": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `password` | string | ClickHouse password |
| `username` | string | ClickHouse username |

<details>
<summary>Example output</summary>

```json
{
  "password": "string",
  "username": "string"
}
```
</details>


SDK reference for `reset-dbaas-clickhouse-user-password`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ResetDBAASClickhouseUserPassword) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reset_dbaas_clickhouse_user_password) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#resetDbaasClickhouseUserPassword(java.lang.String,java.lang.String,com.exoscale.sdk.model.ResetDbaasClickhouseUserPasswordRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api reset-dbaas-clickhouse-user-password`

## <span data-label="POST" class="pill-POST"></span>create-dbaas-integration

```
POST /dbaas-integration
```

[BETA] Create a new DBaaS integration between two services

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `dest-service` | string | **yes** | A destination service<br/><br/>Min length: `0`. Max length: `63`. |
| `integration-type` | string | **yes** | Integration type<br/><br/>Allowed values: `datasource`, `logs`, `metrics`. |
| `source-service` | string | **yes** | A source service<br/><br/>Min length: `0`. Max length: `63`. |
| `settings` | object | no | Integration settings |

<details>
<summary>Example</summary>

```json
{
  "dest-service": "string",
  "integration-type": "datasource",
  "settings": {},
  "source-service": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-dbaas-integration`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateDBAASIntegration) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_dbaas_integration) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createDbaasIntegration(com.exoscale.sdk.model.CreateDbaasIntegrationRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api create-dbaas-integration`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-integration

```
GET /dbaas-integration/{id}
```

[BETA] Get a DBaaS Integration

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `description` | string | Description of the integration |
| `dest` | string | Destination service name |
| `id` | string | Integration id<br/><br/>Must be a valid UUID. |
| `is-active` | boolean | Whether the integration is active or not |
| `is-enabled` | boolean | Whether the integration is enabled or not |
| `settings` | object | Integration settings |
| `source` | string | Source service name |
| `status` | string | Integration status |
| `type` | string | Integration type |

<details>
<summary>Example output</summary>

```json
{
  "description": "string",
  "dest": "string",
  "id": "string",
  "is-active": true,
  "is-enabled": true,
  "settings": {},
  "source": "string",
  "status": "string",
  "type": "string"
}
```
</details>


SDK reference for `get-dbaas-integration`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASIntegration) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_integration) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasIntegration(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-integration`

## <span data-label="PUT" class="pill-PUT"></span>update-dbaas-integration

```
PUT /dbaas-integration/{id}
```

[BETA] Update a existing DBaaS integration

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `settings` | object | **yes** | Integration settings |

<details>
<summary>Example</summary>

```json
{
  "settings": {}
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `update-dbaas-integration`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.UpdateDBAASIntegration) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.update_dbaas_integration) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#updateDbaasIntegration(java.util.UUID,com.exoscale.sdk.model.UpdateDbaasIntegrationRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api update-dbaas-integration`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-dbaas-integration

```
DELETE /dbaas-integration/{id}
```

[BETA] Delete a DBaaS Integration

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-dbaas-integration`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteDBAASIntegration) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_dbaas_integration) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteDbaasIntegration(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api delete-dbaas-integration`

## <span data-label="POST" class="pill-POST"></span>create-dbaas-service-clickhouse

[BETA] Create a DBaaS ClickHouse service

```
POST /dbaas-clickhouse/{name}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `plan` | string | **yes** | Subscription plan<br/><br/>Min length: `1`. Max length: `128`. |
| `clickhouse-settings` | [ClickHouse settings](/reference/api/_schemas/json-schema-clickhouse/) | no | ClickHouse-specific settings |
| `fork-from-service` | string | no | Service to fork from<br/><br/>Min length: `0`. Max length: `63`. |
| `ip-filter` | array[string] | no | Allow incoming connections from CIDR address block, e.g. '10.20.0.0/16' |
| `maintenance` | [Maintenance](#maintenance) | no | Automatic maintenance settings |
| `recovery-backup-name` | string | no | Name of a backup to recover from for services that support backup names<br/><br/>Min length: `1`. |
| `termination-protection` | boolean | no | Service is protected against termination and powering off |
| `version` | string | no | ClickHouse major version<br/><br/>Min length: `1`. |

<details>
<summary>Example</summary>

```json
{
  "clickhouse-settings": {
    "server_settings": {
      "vector_similarity_index_cache_size": 0
    }
  },
  "fork-from-service": "string",
  "ip-filter": [
    "string"
  ],
  "maintenance": {
    "dow": "saturday",
    "time": "string"
  },
  "plan": "string",
  "recovery-backup-name": "string",
  "termination-protection": true,
  "version": "string"
}
```
</details>


### Maintenance {#maintenance}

Automatic maintenance settings

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `dow` | string | **yes** | Day of week for installing updates<br/><br/>Allowed values: `saturday`, `tuesday`, `never`, `wednesday`, `sunday`, `friday`, `monday`, `thursday`. |
| `time` | string | **yes** | Time for installing updates, UTC<br/><br/>Min length: `8`. Max length: `8`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-dbaas-service-clickhouse`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateDBAASServiceClickhouse) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_dbaas_service_clickhouse) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createDbaasServiceClickhouse(java.lang.String,com.exoscale.sdk.model.CreateDbaasServiceClickhouseRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api create-dbaas-service-clickhouse`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-service-clickhouse

[BETA] Get a DBaaS ClickHouse service

```
GET /dbaas-clickhouse/{name}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `backups` | array of [List of backups for the service](/reference/api/_schemas/dbaas-service-backup/) | List of backups for the service |
| `clickhouse-settings` | [ClickHouse settings](/reference/api/_schemas/json-schema-clickhouse/) | ClickHouse-specific settings |
| `components` | array of [Components](/reference/api/_schemas/dbaas-service-clickhouse/#components) | Service component information objects |
| `connection-info` | [Connection Info](/reference/api/_schemas/dbaas-service-clickhouse/#connection-info) | ClickHouse connection information properties |
| `created-at` | string | Service creation timestamp (ISO 8601)<br/><br/>ISO 8601 date-time. |
| `disk-size` | integer | TODO UNIT disk space for data storage<br/><br/>Min: `0`. |
| `integrations` | array of [DBaaS Integration](/reference/api/_schemas/dbaas-integration/) | Service integrations |
| `ip-filter` | array[string] | Allowed CIDR address blocks for incoming connections |
| `maintenance` | [Automatic maintenance settings](/reference/api/_schemas/dbaas-service-maintenance/) | Automatic maintenance settings |
| `name` | string | Service name<br/><br/>Min length: `0`. Max length: `63`. |
| `node-count` | integer | Number of service nodes in the active plan<br/><br/>Min: `0`. |
| `node-cpu-count` | integer | Number of CPUs for each node<br/><br/>Min: `0`. |
| `node-memory` | integer | TODO UNIT of memory for each node<br/><br/>Min: `0`. |
| `node-states` | array of [Automatic maintenance settings](/reference/api/_schemas/dbaas-node-state/) | State of individual service nodes |
| `notifications` | array of [Service notifications](/reference/api/_schemas/dbaas-service-notification/) | Service notifications |
| `plan` | string | Subscription plan |
| `prometheus-uri` | [Prometheus URI](/reference/api/_schemas/dbaas-service-clickhouse/#prometheus-uri) | Prometheus integration URI |
| `state` | string | State of the service<br/><br/>Allowed values: `running`, `rebuilding`, `rebalancing`, `poweroff`. |
| `termination-protection` | boolean | Service is protected against termination and powering off |
| `type` | string | Service type code<br/><br/>Min length: `0`. Max length: `64`. |
| `updated-at` | string | Service last update timestamp (ISO 8601)<br/><br/>ISO 8601 date-time. |
| `uri` | string | URI for connecting to the service (may be absent) |
| `uri-params` | object | service_uri parameterized into key-value pairs |
| `users` | array of [DBaaS Clickhouse User](/reference/api/_schemas/dbaas-clickhouse-user/) | List of ClickHouse users |
| `version` | string | ClickHouse version |
| `zone` | string | The zone where the service is running |

<details>
<summary>Example output</summary>

```json
{
  "backups": [
    {
      "backup-name": "string",
      "backup-time": "2024-01-01T12:00:00Z",
      "data-size": 0
    }
  ],
  "clickhouse-settings": {
    "server_settings": {
      "vector_similarity_index_cache_size": 0
    }
  },
  "components": [
    {
      "component": "string",
      "host": "string",
      "port": 0,
      "route": "dynamic",
      "ssl": true,
      "usage": "primary"
    }
  ],
  "connection-info": {
    "arrowflight-uri": "string",
    "mysql-uri": "string",
    "uri": [
      "string"
    ]
  },
  "created-at": "2024-01-01T12:00:00Z",
  "disk-size": 0,
  "integrations": [
    {
      "description": "string",
      "dest": "string",
      "id": "string",
      "is-active": true,
      "is-enabled": true,
      "settings": {},
      "source": "string",
      "status": "string",
      "type": "string"
    }
  ],
  "ip-filter": [
    "string"
  ],
  "maintenance": {
    "dow": "saturday",
    "time": "string",
    "updates": [
      {
        "deadline": "2024-01-01T12:00:00Z",
        "description": "string",
        "start-after": "2024-01-01T12:00:00Z",
        "start-at": "2024-01-01T12:00:00Z"
      }
    ]
  },
  "name": "string",
  "node-count": 0,
  "node-cpu-count": 0,
  "node-memory": 0,
  "node-states": [
    {
      "name": "string",
      "progress-updates": [
        {
          "completed": true,
          "current": 0,
          "max": 0,
          "min": 0,
          "phase": "stream",
          "unit": "string"
        }
      ],
      "role": "standby",
      "state": "leaving"
    }
  ],
  "notifications": [
    {
      "level": "warning",
      "message": "string",
      "metadata": {},
      "type": "service_powered_off_removal"
    }
  ],
  "plan": "string",
  "prometheus-uri": {
    "host": "string",
    "port": 0
  },
  "state": "running",
  "termination-protection": true,
  "type": "string",
  "updated-at": "2024-01-01T12:00:00Z",
  "uri": "string",
  "uri-params": {},
  "users": [
    {
      "required": true,
      "username": "string",
      "uuid": "string"
    }
  ],
  "version": "string",
  "zone": "string"
}
```
</details>


SDK reference for `get-dbaas-service-clickhouse`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASServiceClickhouse) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_service_clickhouse) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasServiceClickhouse(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-service-clickhouse`

## <span data-label="PUT" class="pill-PUT"></span>update-dbaas-service-clickhouse

[BETA] Update a DBaaS ClickHouse service

```
PUT /dbaas-clickhouse/{name}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `clickhouse-settings` | [ClickHouse settings](/reference/api/_schemas/json-schema-clickhouse/) | no | ClickHouse-specific settings |
| `ip-filter` | array[string] | no | Allow incoming connections from CIDR address block, e.g. '10.20.0.0/16' |
| `maintenance` | [Maintenance](#maintenance) | no | Automatic maintenance settings |
| `plan` | string | no | Subscription plan<br/><br/>Min length: `1`. Max length: `128`. |
| `termination-protection` | boolean | no | Service is protected against termination and powering off |
| `version` | string | no | ClickHouse major version<br/><br/>Min length: `1`. |

<details>
<summary>Example</summary>

```json
{
  "clickhouse-settings": {
    "server_settings": {
      "vector_similarity_index_cache_size": 0
    }
  },
  "ip-filter": [
    "string"
  ],
  "maintenance": {
    "dow": "saturday",
    "time": "string"
  },
  "plan": "string",
  "termination-protection": true,
  "version": "string"
}
```
</details>


### Maintenance {#maintenance}

Automatic maintenance settings

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `dow` | string | **yes** | Day of week for installing updates<br/><br/>Allowed values: `saturday`, `tuesday`, `never`, `wednesday`, `sunday`, `friday`, `monday`, `thursday`. |
| `time` | string | **yes** | Time for installing updates, UTC<br/><br/>Min length: `8`. Max length: `8`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `update-dbaas-service-clickhouse`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.UpdateDBAASServiceClickhouse) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.update_dbaas_service_clickhouse) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#updateDbaasServiceClickhouse(java.lang.String,com.exoscale.sdk.model.UpdateDbaasServiceClickhouseRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api update-dbaas-service-clickhouse`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-dbaas-service-clickhouse

[BETA] Delete a ClickHouse service

```
DELETE /dbaas-clickhouse/{name}
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` |  |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-dbaas-service-clickhouse`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteDBAASServiceClickhouse) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_dbaas_service_clickhouse) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteDbaasServiceClickhouse(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api delete-dbaas-service-clickhouse`


---

## Other Operations

## <span data-label="GET" class="pill-GET"></span>get-dbaas-ca-certificate

Get DBaaS CA Certificate

```
GET /dbaas-ca-certificate
```

Returns a CA Certificate required to reach a DBaaS service through a TLS-protected connection.

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `certificate` | string |  |

<details>
<summary>Example output</summary>

```json
{
  "certificate": "string"
}
```
</details>


SDK reference for `get-dbaas-ca-certificate`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASCACertificate) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_ca_certificate) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasCaCertificate())

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-ca-certificate`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-clickhouse-acl-config

[BETA] Get DBaaS ClickHouse ACL configuration

```
GET /dbaas-clickhouse/{service-name}/acl-config
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `users` | array of [DBaaS Clickhouse User Acl Config](/reference/api/_schemas/dbaas-clickhouse-user-acl-config/) |  |

<details>
<summary>Example output</summary>

```json
{
  "users": [
    {
      "privileges": [
        {
          "access-type": "string",
          "column": "string",
          "database": "string",
          "grant-option": true,
          "partial-revoke": true,
          "table": "string"
        }
      ],
      "roles": [
        {
          "default": true,
          "name": "string",
          "uuid": "string",
          "with-admin-option": true
        }
      ],
      "username": "string",
      "uuid": "string"
    }
  ]
}
```
</details>


SDK reference for `get-dbaas-clickhouse-acl-config`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASClickhouseAclConfig) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_clickhouse_acl_config) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasClickhouseAclConfig(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-clickhouse-acl-config`

## <span data-label="PUT" class="pill-PUT"></span>start-dbaas-clickhouse-maintenance

[BETA] Initiate ClickHouse maintenance update

```
PUT /dbaas-clickhouse/{name}/maintenance/start
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `start-dbaas-clickhouse-maintenance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.StartDBAASClickhouseMaintenance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.start_dbaas_clickhouse_maintenance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#startDbaasClickhouseMaintenance(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api start-dbaas-clickhouse-maintenance`

## <span data-label="GET" class="pill-GET"></span>list-dbaas-clickhouse-users

[BETA] List DBaaS ClickHouse users

```
GET /dbaas-clickhouse/{service-name}/user
```

null

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `users` | array of [DBaaS Clickhouse User](/reference/api/_schemas/dbaas-clickhouse-user/) |  |

<details>
<summary>Example output</summary>

```json
{
  "users": [
    {
      "required": true,
      "username": "string",
      "uuid": "string"
    }
  ]
}
```
</details>


SDK reference for `list-dbaas-clickhouse-users`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListDBAASClickhouseUsers) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_dbaas_clickhouse_users) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listDbaasClickhouseUsers(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api list-dbaas-clickhouse-users`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-external-integration

```
GET /dbaas-external-integration/{integration-id}
```

[BETA] Get a DBaaS external integration

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `integration-id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `description` | string | Description of the integration |
| `dest-endpoint-id` | string | External destination endpoint id |
| `dest-endpoint-name` | string | External destination endpoint name |
| `integration-id` | string | Endpoint integration UUID<br/><br/>Must be a valid UUID. |
| `source-service-name` | string | DBaaS source service name |
| `source-service-type` | string | DBaaS service type<br/><br/>Min length: `0`. Max length: `64`. |
| `status` | string | Integration status |
| `type` | string | Integration Type<br/><br/>Allowed values: `prometheus`, `opensearch`, `rsyslog`, `datadog`, `elasticsearch`. |

<details>
<summary>Example output</summary>

```json
{
  "description": "string",
  "dest-endpoint-id": "string",
  "dest-endpoint-name": "string",
  "integration-id": "string",
  "source-service-name": "string",
  "source-service-type": "string",
  "status": "string",
  "type": "prometheus"
}
```
</details>


SDK reference for `get-dbaas-external-integration`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASExternalIntegration) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_external_integration) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasExternalIntegration(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-external-integration`

## <span data-label="GET" class="pill-GET"></span>list-dbaas-external-integrations

```
GET /dbaas-external-integrations/{service-name}
```

[BETA] List all DBaaS connections between services and external endpoints

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `external-integrations` | array of [Integrations with other services](/reference/api/_schemas/dbaas-external-integration/) |  |

<details>
<summary>Example output</summary>

```json
{
  "external-integrations": [
    {
      "description": "string",
      "dest-endpoint-id": "string",
      "dest-endpoint-name": "string",
      "integration-id": "string",
      "source-service-name": "string",
      "source-service-type": "string",
      "status": "string",
      "type": "prometheus"
    }
  ]
}
```
</details>


SDK reference for `list-dbaas-external-integrations`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListDBAASExternalIntegrations) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_dbaas_external_integrations) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listDbaasExternalIntegrations(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api list-dbaas-external-integrations`

## <span data-label="GET" class="pill-GET"></span>list-dbaas-integration-settings

```
GET /dbaas-integration-settings/{integration-type}/{source-type}/{dest-type}
```

[BETA] Get DBaaS integration settings

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `integration-type` | `path` |  |
| `source-type` | `path` |  |
| `dest-type` | `path` |  |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `settings` | [Settings](#settings) | The JSON schema representing the settings for the given integration type, source, and destination service types. |

<details>
<summary>Example output</summary>

```json
{
  "settings": {
    "additionalProperties": true,
    "properties": {},
    "title": "string",
    "type": "string"
  }
}
```
</details>


### Settings {#settings}

The JSON schema representing the settings for the given integration type, source, and destination service types.

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `additionalProperties` | boolean | no |  |
| `properties` | object | no |  |
| `title` | string | no |  |
| `type` | string | no |  |

SDK reference for `list-dbaas-integration-settings`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListDBAASIntegrationSettings) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_dbaas_integration_settings) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listDbaasIntegrationSettings(java.lang.String,java.lang.String,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api list-dbaas-integration-settings`

## <span data-label="GET" class="pill-GET"></span>list-dbaas-integration-types

```
GET /dbaas-integration-types
```

[BETA] Get DBaaS integration types

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `dbaas-integration-types` | array of [DBaaS Integration Type](/reference/api/_schemas/dbaas-integration-type/) |  |

<details>
<summary>Example output</summary>

```json
{
  "dbaas-integration-types": [
    {
      "dest-description": "string",
      "dest-service-types": [
        "string"
      ],
      "settings": {
        "additionalProperties": true,
        "properties": {},
        "title": "string",
        "type": "string"
      },
      "source-description": "string",
      "source-service-types": [
        "string"
      ],
      "type": "string"
    }
  ]
}
```
</details>


SDK reference for `list-dbaas-integration-types`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListDBAASIntegrationTypes) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_dbaas_integration_types) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listDbaasIntegrationTypes())

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api list-dbaas-integration-types`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-migration-status

Get a DBaaS migration status

```
GET /dbaas-migration-status/{name}
```

Get a DBaaS migration status

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` | Min length: `0`. Max length: `63`. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `details` | array of [Details](/reference/api/_schemas/dbaas-migration-status/#details) | Migration status per database |
| `error` | string | Error message in case that migration has failed |
| `method` | string | Migration method. Empty in case of multiple methods or error |
| `status` | string | Migration status |

<details>
<summary>Example output</summary>

```json
{
  "details": [
    {
      "dbname": "string",
      "error": "string",
      "method": "string",
      "status": "running"
    }
  ],
  "error": "string",
  "method": "string",
  "status": "string"
}
```
</details>


SDK reference for `get-dbaas-migration-status`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASMigrationStatus) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_migration_status) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasMigrationStatus(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-migration-status`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-dbaas-service

Delete a DBaaS service

```
DELETE /dbaas-service/{name}
```

Delete a DBaaS service

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `name` | `path` |  |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-dbaas-service`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteDBAASService) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_dbaas_service) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteDbaasService(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api delete-dbaas-service`

## <span data-label="PUT" class="pill-PUT"></span>detach-dbaas-service-from-endpoint

```
PUT /dbaas-external-endpoint/{source-service-name}/detach
```

[BETA] Detach a DBaaS external integration from a service

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `source-service-name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `integration-id` | string | **yes** | External Integration ID<br/><br/>Must be a valid UUID. |

<details>
<summary>Example</summary>

```json
{
  "integration-id": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `detach-dbaas-service-from-endpoint`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DetachDBAASServiceFromEndpoint) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.detach_dbaas_service_from_endpoint) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#detachDbaasServiceFromEndpoint(java.lang.String,com.exoscale.sdk.model.DetachDbaasServiceFromEndpointRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api detach-dbaas-service-from-endpoint`

## <span data-label="POST" class="pill-POST"></span>get-dbaas-service-logs

Get logs of DBaaS service

```
POST /dbaas-service-logs/{service-name}
```

Get logs of DBaaS service

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` |  |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `limit` | integer | no | How many log entries to receive at most, up to 500 (default: 100)<br/><br/>Min: `1`. Max: `500`. |
| `offset` | string | no | Opaque offset identifier |
| `sort-order` | string | no | Sort order for log messages (default: desc)<br/><br/>Allowed values: `desc`, `asc`. |

<details>
<summary>Example</summary>

```json
{
  "limit": 0,
  "offset": "string",
  "sort-order": "desc"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `first-log-offset` | string |  |
| `logs` | array of [Logs](/reference/api/_schemas/dbaas-service-logs/#logs) |  |
| `offset` | string |  |

<details>
<summary>Example output</summary>

```json
{
  "first-log-offset": "string",
  "logs": [
    {
      "message": "string",
      "node": "string",
      "time": "string",
      "unit": "string"
    }
  ],
  "offset": "string"
}
```
</details>


SDK reference for `get-dbaas-service-logs`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASServiceLogs) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_service_logs) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasServiceLogs(java.lang.String,com.exoscale.sdk.model.GetDbaasServiceLogsRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-service-logs`

## <span data-label="POST" class="pill-POST"></span>get-dbaas-service-metrics

Get metrics of DBaaS service

```
POST /dbaas-service-metrics/{service-name}
```

Get metrics of DBaaS service

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-name` | `path` |  |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `period` | string | no | Metrics time period (default: hour)<br/><br/>Allowed values: `hour`, `week`, `year`, `month`, `day`. |

<details>
<summary>Example</summary>

```json
{
  "period": "hour"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `metrics` | object |  |

<details>
<summary>Example output</summary>

```json
{
  "metrics": {}
}
```
</details>


SDK reference for `get-dbaas-service-metrics`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASServiceMetrics) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_service_metrics) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasServiceMetrics(java.lang.String,com.exoscale.sdk.model.GetDbaasServiceMetricsRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-service-metrics`

## <span data-label="PUT" class="pill-PUT"></span>attach-dbaas-service-to-endpoint

```
PUT /dbaas-external-endpoint/{source-service-name}/attach
```

[BETA] Create a new DBaaS connection between a DBaaS service and an external service

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `source-service-name` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `dest-endpoint-id` | string | **yes** | External endpoint id<br/><br/>Must be a valid UUID. |
| `type` | string | **yes** | External endpoint type<br/><br/>Allowed values: `prometheus`, `opensearch`, `rsyslog`, `datadog`, `elasticsearch`. |

<details>
<summary>Example</summary>

```json
{
  "dest-endpoint-id": "string",
  "type": "prometheus"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `attach-dbaas-service-to-endpoint`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.AttachDBAASServiceToEndpoint) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.attach_dbaas_service_to_endpoint) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#attachDbaasServiceToEndpoint(java.lang.String,com.exoscale.sdk.model.AttachDbaasServiceToEndpointRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api attach-dbaas-service-to-endpoint`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-service-type

Get a DBaaS service type

```
GET /dbaas-service-type/{service-type-name}
```

Get a DBaaS service type

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service-type-name` | `path` |  |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `available-versions` | array[string] | DbaaS service available versions |
| `default-version` | string | DbaaS service default version |
| `description` | string | DbaaS service description |
| `name` | string | DbaaS service name<br/><br/>Min length: `0`. Max length: `64`. |
| `plans` | array of [DBaaS plan](/reference/api/_schemas/dbaas-plan/) | DbaaS service plans |

<details>
<summary>Example output</summary>

```json
{
  "available-versions": [
    "string"
  ],
  "default-version": "string",
  "description": "string",
  "name": "string",
  "plans": [
    {
      "authorized": true,
      "backup-config": {
        "frequent-interval-minutes": 0,
        "frequent-oldest-age-minutes": 0,
        "infrequent-interval-minutes": 0,
        "infrequent-oldest-age-minutes": 0,
        "interval": 0,
        "max-count": 0,
        "recovery-mode": "string"
      },
      "disk-space": 0,
      "family": "string",
      "max-memory-percent": 0,
      "name": "string",
      "node-count": 0,
      "node-cpu-count": 0,
      "node-memory": 0,
      "zones": [
        "string"
      ]
    }
  ]
}
```
</details>


SDK reference for `get-dbaas-service-type`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASServiceType) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_service_type) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasServiceType(java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-service-type`

## <span data-label="GET" class="pill-GET"></span>list-dbaas-service-types

DBaaS Service Types

```
GET /dbaas-service-type
```

List available service types for DBaaS

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `dbaas-service-types` | array of [DBaaS service](/reference/api/_schemas/dbaas-service-type/) |  |

<details>
<summary>Example output</summary>

```json
{
  "dbaas-service-types": [
    {
      "available-versions": [
        "string"
      ],
      "default-version": "string",
      "description": "string",
      "name": "string",
      "plans": [
        {
          "authorized": true,
          "backup-config": {
            "frequent-interval-minutes": null,
            "frequent-oldest-age-minutes": null,
            "infrequent-interval-minutes": null,
            "infrequent-oldest-age-minutes": null,
            "interval": null,
            "max-count": null,
            "recovery-mode": null
          },
          "disk-space": 0,
          "family": "string",
          "max-memory-percent": 0,
          "name": "string",
          "node-count": 0,
          "node-cpu-count": 0,
          "node-memory": 0,
          "zones": [
            null
          ]
        }
      ]
    }
  ]
}
```
</details>


SDK reference for `list-dbaas-service-types`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListDBAASServiceTypes) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_dbaas_service_types) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listDbaasServiceTypes())

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api list-dbaas-service-types`

## <span data-label="GET" class="pill-GET"></span>list-dbaas-services

List DBaaS services

```
GET /dbaas-service
```

List DBaaS services

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `dbaas-services` | array of [DBaaS Service Common](/reference/api/_schemas/dbaas-service-common/) |  |

<details>
<summary>Example output</summary>

```json
{
  "dbaas-services": [
    {
      "created-at": "2024-01-01T12:00:00Z",
      "disk-size": 0,
      "integrations": [
        {
          "description": "string",
          "dest": "string",
          "id": "string",
          "is-active": true,
          "is-enabled": true,
          "settings": {},
          "source": "string",
          "status": "string",
          "type": "string"
        }
      ],
      "name": "string",
      "node-count": 0,
      "node-cpu-count": 0,
      "node-memory": 0,
      "notifications": [
        {
          "level": "warning",
          "message": "string",
          "metadata": {},
          "type": "service_powered_off_removal"
        }
      ],
      "plan": "string",
      "state": "running",
      "termination-protection": true,
      "type": "string",
      "updated-at": "2024-01-01T12:00:00Z",
      "zone": "string"
    }
  ]
}
```
</details>


SDK reference for `list-dbaas-services`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListDBAASServices) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_dbaas_services) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listDbaasServices())

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api list-dbaas-services`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-settings-clickhouse

[BETA] Get DBaaS ClickHouse settings

```
GET /dbaas-settings-clickhouse
```

null

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `settings` | [Settings](#settings) |  |

<details>
<summary>Example output</summary>

```json
{
  "settings": {
    "clickhouse": {
      "additionalProperties": true,
      "properties": {},
      "title": "string",
      "type": "string"
    }
  }
}
```
</details>


### Settings {#settings}

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `clickhouse` | [Clickhouse](#clickhouse) | no | ClickHouse configuration values |

### Clickhouse {#clickhouse}

ClickHouse configuration values

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `additionalProperties` | boolean | no |  |
| `properties` | object | no |  |
| `title` | string | no |  |
| `type` | string | no |  |

SDK reference for `get-dbaas-settings-clickhouse`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASSettingsClickhouse) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_settings_clickhouse) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasSettingsClickhouse())

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-settings-clickhouse`

## <span data-label="GET" class="pill-GET"></span>get-dbaas-task

Get a DBaaS task

```
GET /dbaas-task/{service}/{id}
```

Get a DBaaS task

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service` | `path` | Min length: `0`. Max length: `63`. |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `create-time` | string | ISO 8601 date-time. |
| `id` | string | Must be a valid UUID. |
| `result` | string |  |
| `result-codes` | array of [Result Codes](/reference/api/_schemas/dbaas-task/#result-codes) |  |
| `success` | boolean |  |
| `task-type` | string |  |

<details>
<summary>Example output</summary>

```json
{
  "create-time": "2024-01-01T12:00:00Z",
  "id": "string",
  "result": "string",
  "result-codes": [
    {
      "code": "string",
      "dbname": "string"
    }
  ],
  "success": true,
  "task-type": "string"
}
```
</details>


SDK reference for `get-dbaas-task`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetDBAASTask) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_dbaas_task) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getDbaasTask(java.lang.String,java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api get-dbaas-task`

## <span data-label="POST" class="pill-POST"></span>create-dbaas-task-migration-check

```
POST /dbaas-task-migration-check/{service}
```

Create a DBaaS task to check migration

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `service` | `path` | Min length: `0`. Max length: `63`. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `source-service-uri` | string | **yes** | Service URI of the source MySQL or PostgreSQL database with admin credentials.<br/><br/>Min length: `1`. Max length: `512`. |
| `ignore-dbs` | string | no | Comma-separated list of databases, which should be ignored during migration (supported by MySQL only at the moment)<br/><br/>Min length: `1`. Max length: `2048`. |
| `method` | string | no | The migration method to be used (currently supported only by MySQL service type)<br/><br/>Allowed values: `dump`, `replication`. |

<details>
<summary>Example</summary>

```json
{
  "ignore-dbs": "string",
  "method": "dump",
  "source-service-uri": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](/reference/api/_schemas/operation/#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-dbaas-task-migration-check`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateDBAASTaskMigrationCheck) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_dbaas_task_migration_check) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createDbaasTaskMigrationCheck(java.lang.String,com.exoscale.sdk.model.CreateDbaasTaskMigrationCheckRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/): `exo api create-dbaas-task-migration-check`


